function [bst,context,sigma,ppi,A,C,T,L,tbar,coded]=MQ_Ecoder_Pass0(bp,sigma,sgn,ppi,context,A,C,T,L,tbar,subband)

[M,N] = size(bp);
nStripes = ceil(M/4);
bst=[];
coded = zeros(M,N);
for n=1:nStripes
    str = bp(4*(n-1)+1:min(4*n,M),1:N);
    M2 = size(str,1);
    for j2=1:N
        for j1=1:M2
            j = 4*(n-1)+j1;
            k=find_ksig(sigma,j1+4*(n-1),j2,subband);
            if ((sigma(4*(n-1)+j1,j2)==0) && (k>0))
                x=str(j1,j2);
                [bs,context,A,C,T,L,tbar]=MQ_Encode(x,k,context,A,C,T,L,tbar);
                bst = [bst bs];
                if (str(j1,j2)==1)
                   sigma(j1+4*(n-1),j2)=1;
                   [bs,context,A,C,T,L,tbar]=Encode_Sign(bp,sigma,sgn,j1+4*(n-1),j2,context,A,C,T,L,tbar);
                   bst = [bst bs];
                end
                ppi(j1+4*(n-1),j2)=1;
                coded(j1+4*(n-1),j2)=1;
            else
                ppi(j1+4*(n-1),j2)=0;
            end
        end
    end
end
        