function [error,psnr]=mse(x,y,B)
% Computes the mean square error between two images x,y in the range [0,1]
% expressed with B-bits
% x must be a double image

[M,N]=size(x);
ymax=max(y(:));
ymin=min(y(:));
yr=255*(y-ymin)/(ymax-ymin);
%x=imadjust(x,[],[0;1]);
%xr = round((2^B-1)*x);
xr = 255*(x-min(x(:)))/(max(x(:))-min(x(:)));
%yr = round((2^B-1)*y);
%yr = im2uint8(y);
mError = (xr-yr).^2;
error = sum(mError(:))/(N*M);

psnr=10*log10((2^B-1)^2/error);

% [error,psnr]=mse(x,y,8);
% [y2 y3]=im2jpeg2k(x,3,0.125);yrec=jpeg2k2im(y3,3,0.125);y1=imadjust(yrec);[error(2),psnr(2)]=mse(xd,y1,8)