function [bst,context,A,C,T,L,tbar,coded]=MQ_Ecoder_Pass1(bp,sigma,sigma_ant,ppi,context,A,C,T,L,tbar,subband)
% Magnitude refinement

[M,N] = size(bp);
nStripes = ceil(M/4);
bst=[];
coded = zeros(M,N);

for n=1:nStripes
    str = bp(4*(n-1)+1:min(4*n,M),1:N);
    M2 = size(str,1);
    for j2=1:N
        for j1=1:M2
            if ((sigma(4*(n-1)+j1,j2)==1) && (ppi(4*(n-1)+j1,j2)==0))
                ksig=find_ksig(sigma,j1+4*(n-1),j2,subband);
                if (sigma_ant(4*(n-1)+j1,j2)==0)
                    if (ksig > 0)
                        kmag = 16;
                    else
                        kmag = 15;
                    end
                else
                    kmag = 17;
                end
                x=str(j1,j2);
                coded(j1+4*(n-1),j2)=1;
                [bs,context,A,C,T,L,tbar]=MQ_Encode(x,kmag,context,A,C,T,L,tbar);
                bst = [bst bs];
            end
        end
    end
end

