function energyRatio(imgName,N)

img2 = imread(imgName);
img = im2double(img2)*255;

s = size(img);

ratioEnergy=zeros(1,N);
erms=zeros(1,N);

imgNorm = norm(img/255);

for k=1:N
    [recImg, err]=jpegColor(imgName,k,0);
    ratioEnergy(k)=norm(recImg/255)/imgNorm;
    error=(recImg-img)/255;
    erms(k)=sqrt(sum(error(:).^2)/(s(1)*s(2)));
end

k=1:N;
figure;
plot(k,ratioEnergy,'-o');title('Energy ratio');
figure;
plot(k,erms,'-o');title('Mean Square Error');
xlim([1 N]);