function [recImg,qMat,DC,numACcoeff]=jpeg1(img,k,color)

s=size(img);
M=s(1);
N=s(2);

nRowBk = M/8;
nColBk = N/8;
qMat=zeros(M,N);
recImg=zeros(M,N);
DC = zeros(1,nRowBk*nColBk);

n=1;
for j=1:nRowBk
    for r=1:nColBk
        block = img((j-1)*8+1:j*8,(r-1)*8+1:r*8);
        [B,qB,dctB]=jpegBlock(block,k,color);
        qMat((j-1)*8+1:j*8,(r-1)*8+1:r*8)=qB;
        %recImg((j-1)*8+1:j*8,(r-1)*8+1:r*8)=B/255;
        recImg((j-1)*8+1:j*8,(r-1)*8+1:r*8)=B;
        %Compute the number of AC coefficients different from zero
        numACcoeff(n)= 64 - histc(qB(:),0);
        %SAve the DC coefficient of the block n
        DC(n)=qB(1,1);
        n=n+1;
    end
end
%figure;
%subplot(1,2,1);imshow(qMat);
%subplot(1,2,2);imshow(recImg);

%[recImg,qMat,DC,numACcoeff]=jpeg1(y,1.0);