function y=jpeg2k2im(x,res,bpp)

% Compute multiresolution res bi-orthogonal inverse wavelet 7-9
y=x;
[M N] = size(x);

z1=x(1:M/2^(res-1),1:N/2^(res-1));
z=invBiOrthogonalWavelet79(z1,0);
y(1:M/2^(res-1),1:N/2^(res-1)) = z.comp;    
%imshow(y,[]);title('Recovered Image');
for k=res-1:-1:1
    z1=y(1:M/2^(k-1),1:N/2^(k-1));
    z=invBiOrthogonalWavelet79(z1,0);
    y(1:M/2^(k-1),1:N/2^(k-1)) = z.comp;
    %imshow(y,[]);title('Recovered Image');
end

maxim=max(y(:));
minim=min(y(:));

%y=imadjust(y); % Rescale the image between 0 and 1.

figure;imshow(y,[]);title(['Recovered Image at rate: ', num2str(bpp)]);

%yrec=jpeg2k2im(ycomp,3,0.125);