function [yrec,y4]=jpeg2kdwt2img(y2,data,bpp)

maxRate = data.size(1)*data.size(2)*bpp;
[~,I]=sort(data.slopesVect); % Vector I indexes the numbers of blocks with least slopes
sumRate = cumsum(data.rateVect(I));
indRate = find(sumRate<=maxRate,1,'last');

cb_size=data.cb_size;
%layer1=y2(1).wRec
y3 = zeros(data.size);
lx = size(y3,2)/cb_size;

numBlocks = size(y3,1)*size(y3,2)/(cb_size*cb_size);
nextPoint = ones(1,numBlocks);

for k=1:indRate
    j=data.idBlockVect(I(k));
    %q = rem(j-1,lx)+1;
    %p = fix((j-1)/lx) + 1;
    r = nextPoint(j);
    %y3((p-1)*cb_size+1:p*cb_size,(q-1)*cb_size+1:q*cb_size) = reshape(y2(j).wRec(r,:),[cb_size cb_size]);
    y3(y2(j).x:y2(j).x+cb_size-1,y2(j).y:y2(j).y+cb_size-1) = reshape(y2(j).wRec(r,:),[cb_size cb_size]);
    nextPoint(j) = nextPoint(j) + 1;
end

figure;imshow(y3,[]);title(['DWT truncated at rate: ', num2str(bpp)]);
%sm=max(y2(1).slope)
%x=imread('lenna.jpg');x=rgb2gray(x);[y2 y3]=im2jpeg2k(x,3,0.125);

y4=y3/127*data.max;
%yrec=jpeg2k2im(y3,data.res,bpp);
yrec=jpeg2k2im(y4,data.res,bpp);


% Example
% yrec=jpeg2kdwt2img(y2,data,0.0625);
